/*
  $Id: JLdapControlHandler.java 2616 2013-02-12 18:06:47Z dfisher $

  Copyright (C) 2003-2013 Virginia Tech.
  All rights reserved.

  SEE LICENSE FOR MORE INFORMATION

  Author:  Middleware Services
  Email:   middleware@vt.edu
  Version: $Revision: 2616 $
  Updated: $Date: 2013-02-12 13:06:47 -0500 (Tue, 12 Feb 2013) $
*/
package org.ldaptive.provider.jldap;

import org.ldaptive.control.ControlFactory;
import org.ldaptive.control.RequestControl;
import org.ldaptive.control.ResponseControl;
import org.ldaptive.provider.ControlHandler;

/**
 * JLdap control handler.
 *
 * @author  Middleware Services
 * @version  $Revision: 2616 $ $Date: 2013-02-12 13:06:47 -0500 (Tue, 12 Feb 2013) $
 */
public class JLdapControlHandler
  implements ControlHandler<com.novell.ldap.LDAPControl>
{


  /** {@inheritDoc} */
  @Override
  public String getOID(final com.novell.ldap.LDAPControl control)
  {
    return control.getID();
  }


  /** {@inheritDoc} */
  @Override
  public com.novell.ldap.LDAPControl handleRequest(
    final RequestControl requestControl)
  {
    return
      new com.novell.ldap.LDAPControl(
        requestControl.getOID(),
        requestControl.getCriticality(),
        requestControl.encode());
  }


  /** {@inheritDoc} */
  @Override
  public ResponseControl handleResponse(
    final com.novell.ldap.LDAPControl responseControl)
  {
    return
      ControlFactory.createResponseControl(
        responseControl.getID(),
        responseControl.isCritical(),
        responseControl.getValue());
  }
}
